//Task: salaries
//Author: Rusko Shikov
//Solution: O(N^2)
#include <cstdio>
#include <time.h>
#include <iostream>
using namespace std;

const int nmax=100000;
const int smax=100000;

int sal[2][nmax+2];

int n;

void input()
{
  int i;
  scanf("%d",&n);
  for (i=1;i<=n;i++)
    scanf("%d",&sal[0][i]);  
}

bool compare_sal()
{
    int i,j;
    for (i=1;i<n;i++)
      for (j=i+1;j<=n;j++)
        if (((sal[0][i]==sal[0][j])&&(sal[1][i]!=sal[1][j])) ||
            ((sal[0][i]<sal[0][j])&&(sal[1][i]>=sal[1][j])) ||
            ((sal[0][i]>sal[0][j])&&(sal[1][i]<=sal[1][j])))
           return false;
    return true;         
}

int main()
{
    //clock_t begin, end;
    //double time_spent;

    //begin = clock();
  /* here, do your time-consuming job */
    int i,j,k=0,it=0;
    bool finish=false;
    bool eq;
    
    input();
    while (!finish)
    {
        eq=true;
        it++;
        for (i=1;i<n;i++)
        {
            for (j=i+1;(j<=n)&& (sal[k][j]<=sal[k][i]);j++);
            if (j>n)
              sal[1-k][i]=sal[k][i];
            else
              sal[1-k][i]=(sal[k][i]+sal[k][j])/2;
            if (sal[0][i]!=sal[1][i]) eq=false;    
        }
        sal[1-k][n]=sal[k][n];
        k=1-k;
        if (eq || (it==13))
            finish=true;
        else
          if (!compare_sal()) finish=true;           
        
    }
    for (i=1;i<=n;i++)
      printf("%d\n", sal[1-k][i]);
      
    //printf("%d\n",it);
    //end = clock();
    //time_spent = (double)(end - begin) / CLOCKS_PER_SEC;
    //cout << time_spent;
}